=== debian/changelog ===
xmlrpc-c (1.60.05-1) unstable; urgency=medium

  * New upstream version 1.60.05
  * Drop "Rules-Requires-Root: no": it is now the default
  * Refresh patches
  * Install new usr/lib/*/libxmlrpc_openssl.*

 -- Alexandre Detiste <tchet@debian.org>  Sat, 20 Dec 2025 15:26:38 +0100
